"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var apputils_1 = require("@jupyterlab/apputils");
var widgets_1 = require("@phosphor/widgets");
/**
 * Show a dialog for entering MapD connection data.
 */
function showConnectionDialog(oldConnection) {
    return apputils_1.showDialog({
        title: 'MapD Connection',
        body: new MapDConnectionDialog(oldConnection),
        buttons: [apputils_1.Dialog.cancelButton(), apputils_1.Dialog.okButton()],
    }).then(function (result) {
        if (result.button.accept) {
            return result.value;
        }
        else {
            return oldConnection;
        }
    });
}
exports.showConnectionDialog = showConnectionDialog;
/**
 * A dialog for entering MapD connection data.
 */
var MapDConnectionDialog = /** @class */ (function (_super) {
    __extends(MapDConnectionDialog, _super);
    function MapDConnectionDialog(oldData) {
        var _this = _super.call(this) || this;
        var layout = _this.layout = new widgets_1.PanelLayout();
        _this._user = document.createElement('input');
        _this._password = document.createElement('input');
        _this._database = document.createElement('input');
        _this._host = document.createElement('input');
        _this._protocol = document.createElement('input');
        _this._port = document.createElement('input');
        _this._user.placeholder = 'User name';
        _this._password.placeholder = 'Password';
        _this._database.placeholder = 'Database name';
        _this._host.placeholder = 'Host name';
        _this._protocol.placeholder = 'Protocol';
        _this._port.placeholder = 'Port';
        if (oldData) {
            _this._user.value = oldData.user;
            _this._password.value = oldData.password;
            _this._database.value = oldData.dbName;
            _this._host.value = oldData.host;
            _this._protocol.value = oldData.protocol;
            _this._port.value = oldData.port;
        }
        var userLabel = new widgets_1.Widget();
        userLabel.node.textContent = 'User';
        var passwordLabel = new widgets_1.Widget();
        passwordLabel.node.textContent = 'Password';
        var databaseLabel = new widgets_1.Widget();
        databaseLabel.node.textContent = 'Database';
        var hostLabel = new widgets_1.Widget();
        hostLabel.node.textContent = 'Host';
        var protocolLabel = new widgets_1.Widget();
        protocolLabel.node.textContent = 'Protocol';
        var portLabel = new widgets_1.Widget();
        portLabel.node.textContent = 'Port';
        layout.addWidget(userLabel);
        layout.addWidget(new widgets_1.Widget({ node: _this._user }));
        layout.addWidget(passwordLabel);
        layout.addWidget(new widgets_1.Widget({ node: _this._password }));
        layout.addWidget(databaseLabel);
        layout.addWidget(new widgets_1.Widget({ node: _this._database }));
        layout.addWidget(hostLabel);
        layout.addWidget(new widgets_1.Widget({ node: _this._host }));
        layout.addWidget(protocolLabel);
        layout.addWidget(new widgets_1.Widget({ node: _this._protocol }));
        layout.addWidget(portLabel);
        layout.addWidget(new widgets_1.Widget({ node: _this._port }));
        return _this;
    }
    MapDConnectionDialog.prototype.getValue = function () {
        return {
            user: this._user.value,
            password: this._password.value,
            dbName: this._database.value,
            host: this._host.value,
            protocol: this._protocol.value,
            port: this._port.value
        };
    };
    return MapDConnectionDialog;
}(widgets_1.Widget));
exports.MapDConnectionDialog = MapDConnectionDialog;
